/*
HMPopUpButtonCell.h

Author: MIURA Kazki

Copyright 2004-2006 The Shiira Project. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted 
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions 
  and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of 
  conditions and the following disclaimer in the documentation and/or other materials provided 
  with the distribution.

THIS SOFTWARE IS PROVIDED BY THE SHIIRA PROJECT ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE SHIIRA PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.
*/

#import <Cocoa/Cocoa.h>

typedef enum _HMPopUpType {
	HMNormalPopUp = 0,
	HMSolidPopUp = 1,
	HMPopUpTypeCount = 2
} HMPopUpType;


@interface HMPopUpButtonCell : NSPopUpButtonCell
{
	NSImage *_arrowImage;
	NSImage *_bezelImage, *_alternateBezelImage;
	int _popUpType;
	NSMutableDictionary *_titleAttributes;
}

// Arrow
- (NSImage*)arrowImage;
- (void)setArrowImage:(NSImage*)image;

// Drawing
- (void)drawArrowWithFrame:(NSRect)cellFrame inView:(NSView*)controlView;

// PopUpType
- (HMPopUpType)popUpType;
- (void)setPopUpType:(HMPopUpType)type;		// This method resets appearance related values such as title attributes

// Size
- (NSRect)arrowRectForBounds:(NSRect)theRect;

// Title
- (NSDictionary*)titleAttributes;
- (void)setTitleAttributes:(NSDictionary*)attributes;		// Note: This method may causes conflicts between title attributes and cell attributes (eg. text alignmen)

@end
